'Compilable Example:
#Compiler PBWin 10
#Compile Exe  "gbhexviewer_re.exe"
#Dim All

#Debug Error On
#Debug Display On

%Unicode=1
#Include Once "win32api.inc"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "images\gbhexviewer.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon xopen "images\open.ico"
#Resource Icon xsettings "images\settings.ico"
#Resource Icon xsearch "images\search.ico"
#Resource Icon xfont "images\font.ico"

$Ver = "1.11"

Enum Equates Singular
   IDC_Toolbar = 500
   IDC_RichEdit
   IDC_StatusBar

   IDT_Open
   IDT_Search
   IDT_Font
   IDT_HexView
   IDT_Settings
   IDT_Help

   IDM_Test
   IDM_Debug

   IDM_Next
   IDM_Previous

   IDS_FindThisLabel
   IDS_SearchTerm
   IDS_SearchNext
   IDS_SearchPrevious
   IDS_CaseSensitive

   IDM_Sep
   IDM_Copy
   IDM_HexWidth8
   IDM_HexWidth16
   IDM_SetHexWidth
   IDM_AutoWidth
   IDM_SetGoodChar

End Enum

Global hDlg, hRichEdit, hToolbar, ghHook As Dword
Global hFont, hFontToolbar, hSearch, hSettings, hContextTV As Dword
Global FileName, FontName, SearchTerm, GoodChar As WStringZ * %Max_Path
Global FontSize, FontAttr, HexWidth, CustomHexWidth As Long
Global FileSize, CaseSensitive,Debug As Long
Global SearchDirection, SearchDialogShown, HexView, AutoWidth, OldREProc As Long
Global FileGulp$, FT As FindTextEx

Function PBMain() As Long
   Dialog New Pixels, 0, "gbHexViewer   v" + $ver,300,300,200,200, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   DragAcceptFiles hDlg, %True
   CreateRichEdit
   CreateToolbar
   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0, 0, 0, 0
   Statusbar Set Parts hDlg, %IDC_StatusBar, 200, 99999
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
'   If Debug Then Txt.Print FuncName$ ... disabled by choice
   Local temp$, iReturn As Long, pt As PointAPI, rc As Rect
   Local nmtb As TBNotify Ptr, PTT As TooltipText Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog
         OldREProc = SetWindowLong(hRichEdit, %GWL_WndProc, CodePtr(NewREProc))  'subclass
         settings_ini "get"
         ManageDebug
         If IsFile(Command$) Then FileName = LCase$(Command$)
         BuildAcceleratorTable
         Font New FontName, FontSize, FontAttr To hFont
         Control Set Font hDlg, %IDC_RichEdit, hFont
         Control Set Font hDlg, %IDC_StatusBar, hFontToolbar
         If IsFile(FileName) Then
            OpenHexFileName
         Else
            If IsFile(Exe.Full$) Then FileName = Exe.Full$ : OpenHexFileName
         End If
         SetMenusAndToolbar
         UpdateDialogStatusBar

      Case %WM_Destroy
         SetWindowLong hRichEdit, %GWL_WNDPROC, OldREProc   'un-subclass
         settings_ini "save"
         SetMenusAndToolbar

      Case %WM_Size
         ResizeWindow

      Case %WM_DROPFILES
         temp$ = GetDroppedFileName(Cb.WParam)
         DragFinish Cb.WParam
         If IsFile(temp$) Then
            FileName = LCase$(temp$)
            OpenHexFileName
         End If

      Case %WM_ContextMenu
         pt.x = Lo(Integer,Cb.LParam) : pt.y = Hi(Integer, Cb.LParam)
         Select Case Cb.WParam
            Case hRichEdit
               TrackPopupMenu hContextTV, %TPM_LeftAlign, pt.x, pt.y, 0, Cb.Hndl, ByVal 0
         End Select

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_Open     : SelectAndOpenFile
            Case %IDT_Settings
               Select Case HexWidth
                  Case 8    : HexWidth = 16
                  Case 16   : HexWidth = CustomHexWidth
                  Case Else : HexWidth = 8
               End Select
               OpenHexFileName
               If AutoWidth Then SetDialogWidth
               UpdateDialogStatusBar

            Case %IDT_Search   : DisplaySearchDialog
            Case %IDT_Font     : SelectMainFont

            Case %IDT_HexView
               HexView Xor= 1
               OpenHexFileName
               SetMenusAndToolbar

            Case %IDT_Help
               temp$ = "http://www.garybeene.com/sw/gbhexviewer_re.htm"
               iReturn = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_SetHexWidth
               iReturn = HexWidth
               SetHexWidth
               If iReturn <> HexWidth Then
                  OpenHexFileName
                  If AutoWidth Then SetDialogWidth
               End If

            Case %IDM_HexWidth8
               If HexWidth <> 8 Then
                 HexWidth = 8
                 OpenHexFileName
                 If AutoWidth Then SetDialogWidth
               End If

            Case %IDM_HexWidth16
               If HexWidth <> 16 Then
                  HexWidth = 16
                  OpenHexFileName
                  If AutoWidth Then SetDialogWidth
               End If

            Case %IDM_AutoWidth
               AutoWidth Xor= 1
               If AutoWidth Then SetDialogWidth
               SetMenusAndToolbar

            Case %IDM_SetGoodChar
               temp$ = GoodChar
               SetGoodCharacters
               If temp$ <> GoodChar Then OpenHexFileName

            Case %IDM_Copy : SendMessage GetFocus, %WM_Copy, 0, 0

            Case %IDM_Next                                                   'search forward
               SearchNext
            Case %IDM_Previous                                                'search backward
               SearchPrevious

            Case %IDM_Test

            Case %IDM_Debug
               Debug Xor= 1
               ManageDebug

         End Select

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_Open To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_Open     : @PTT.@lpszText = "Open File Selection Dialog"
                        Case %IDT_Search   : @PTT.@lpszText = "Find Dialog"
                        Case %IDT_Open     : @PTT.@lpszText = "Open File Selection Dialog"
                        Case %IDT_Settings : @PTT.@lpszText = "Settings"
                     End Select
               End Select
            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     Select Case @nmtb.iItem
                        Case %IDT_Settings
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select
         End Select
   End Select
End Function

Sub Settings_INI(Task$)
   If Debug Then Txt.Print FuncName$
   Local x, y As Long, xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "400", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "300", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Courier New", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileName", Exe.Path$ + "files\give_me_a_home.txt", FileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SearchTerm", "OD", SearchTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "GoodChar", Chr$(48 To 57, 65 To 90, 97 To 122), GoodChar, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "HexWidth", "8", temp, %Max_Path, INIFileName:  HexWidth = Val(temp)
      Getprivateprofilestring "All", "CaseSensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)
      Getprivateprofilestring "All", "SearchDirection", "1", temp, %Max_Path, INIFileName:  SearchDirection = Val(temp)
      Getprivateprofilestring "All", "HexView", "1", temp, %Max_Path, INIFileName:  HexView = Val(temp)
      Getprivateprofilestring "All", "AutoWidth", "1", temp, %Max_Path, INIFileName:  AutoWidth = Val(temp)
      Getprivateprofilestring "All", "CustomHexWidth", "32", temp, %Max_Path, INIFileName:  CustomHexWidth = Val(temp)

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName
      WritePrivateProfileString "All", "GoodChar",GoodChar, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "HexWidth", (Str$(HexWidth)), INIFileName
      WritePrivateProfileString "All", "CaseSensitive", (Str$(CaseSensitive)), INIFileName
      WritePrivateProfileString "All", "SearchDirection", (Str$(SearchDirection)), INIFileName
      WritePrivateProfileString "All", "HexView", Str$(HexView), INIFileName
      WritePrivateProfileString "All", "AutoWidth", (Str$(AutoWidth)), INIFileName
      WritePrivateProfileString "All", "CustomHexWidth", (Str$(CustomHexWidth)), INIFileName
   End If
End Sub

Sub CreateRichEdit
   If Debug Then Txt.Print FuncName$
   Local style&
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
         Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop Or %ES_ReadOnly Or %ES_NoHideSel
   LoadLibrary("riched20.dll") : InitCommonControls
   Control Add "RichEdit20A", hDlg, %IDC_RichEdit, "", 0,60,400,280, style& , %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_RichEdit To hRichEdit

   Menu New PopUp To hContextTV
   Menu Add String, hContextTV, "Copy",  %IDM_Copy,  %MF_Enabled
End Sub

Sub CreateToolbar
    If Debug Then Txt.Print FuncName$
    Local hImageList As Dword

    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "xopen"     '1
    ImageList Add Icon hImageList, "xsettings" '2
    ImageList Add Icon hImageList, "xhelp"     '3
    ImageList Add Icon hImageList, "xfont"     '4
    ImageList Add Icon hImageList, "xsearch"   '5
    ImageList Add Icon hImageList, "logo"      '6

    Menu New PopUp To hSettings
    Menu Add String, hSettings, "Auto-Adjust Dialog Width", %IDM_AutoWidth, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Set Visible Characters", %IDM_SetGoodChar, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Set Hex Width", %IDM_SetHexWidth, %MF_Enabled
    Menu Add String, hSettings, "Set Hex Width= 8", %IDM_HexWidth8, %MF_Enabled
    Menu Add String, hSettings, "Set Hex Width = 16", %IDM_HexWidth16, %MF_Enabled

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist

    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Open,  %TbStyle_Button, "Open"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Search,  %TbStyle_Button, "Search"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_HexView,  %TbStyle_Check, "Hex View"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Font,  %TbStyle_Button, "Font"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Settings,  %TbStyle_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Help,  %TbStyle_Button, "Help"

    Font New "Tahoma", 10, 0 To hFontToolbar
    Control Set Font hDlg, %IDC_Toolbar, hFontToolbar
End Sub

Sub ResizeWindow
   If Debug Then Txt.Print FuncName$
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_RichEdit, w, h-85
End Sub

Function SelectAndOpenFile As Long
    If Debug Then Txt.Print FuncName$
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "All Files (*.*)" + $Nul + "*.*" + $Nul
    startfolder$ = PathName$(Path,FileName)
    startfile$ = FileName
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "Open File", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&

    If Len(filevar$) Then
       FileName = LCase$(filevar$)
       OpenHexFileName
    End If
End Function

Sub BuildAcceleratorTable
   If Debug Then Txt.Print FuncName$
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(8)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help     : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3 : ac(c).cmd   = %IDT_Search   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D  : ac(c).cmd   = %IDM_Debug    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F  : ac(c).cmd   = %IDT_Search   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_H  : ac(c).cmd   = %IDT_HexView  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_O  : ac(c).cmd   = %IDT_Open     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N  : ac(c).cmd   = %IDM_Next     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P  : ac(c).cmd   = %IDM_Previous : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd   = %IDM_Test     : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function GetDroppedFileName(hDrop As Dword) As String
   If Debug Then Txt.Print FuncName$
   Local fString As WStringZ*%Max_Path, Count As Long
   fString=Space$(%Max_Path)
   Count = DragQueryFile(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
   Function = Left$(fString,Count)                        ' put Count chars into result string
End Function

Sub SelectMainFont
   If Debug Then Txt.Print FuncName$
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx ghHook
   If Len(fName) Then
      FontName = fName
      FontSize = fPoints
      FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
      Control Set Font hDlg, %IDC_RichEdit, hFont
      If AutoWidth Then SetDialogWidth
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
'   If Debug Then Txt.Print FuncName$ ... disabled by choice
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal WParam, ByVal LParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Function OpenHexFileName() As Long
   If Debug Then Txt.Print FuncName$
   Open FileName For Binary As #1
   FileSize = Lof(1)
   Get$ #1,FileSize, FileGulp$
   Close #1
   Control Set Text hDlg, %IDC_RichEdit, IIf$(HexView, ConvertToHex(FileGulp$), FileGulp$)
   UpdateDialogStatusBar
End Function

Function ConvertToHex(TextData$) As String
   If Debug Then Txt.Print FuncName$
   Local i,j,iPos,Rows,tLength,TextPos As Long
   Local pHexDigit, pHexTable, pTextData, pBuffer As Byte Ptr
   Local Buffer$, HexTable$, HexDigit$, BadChar$, HexTemplate$
   Local Rep() As Byte

   'initialize
   ReDim Rep(255)
   BadChar$ = Remove$(Chr$(0 To 255), Any GoodChar)

   For i = 0 To 255
      If InStr(BadChar$,Chr$(i)) Then Rep(i) = Asc(".") Else Rep(i) = i
   Next i
   For i = 0 To 255 : HexTable$ += Hex$(i,2) : Next i
   For i = 0 To 15  : HexDigit$ += Hex$(i,1) : Next i

   HexTemplate$ = Space$(7) + ":" + Space$(3*HexWidth+1) + ":" + Space$(HexWidth+1) + $CrLf  '77
   tLength = 7 + 1 + 3 * HexWidth + 1 + 1 + HexWidth + 1 + 2
   TextPos    = 7 + 1 + 3 * HexWidth + 1 + 1 + 1

   'create empty Buffer$ (contains only rows of templates
   If Len(TextData$) Mod HexWidth Then TextData$ += String$(16 - Len(TextData$) Mod 16, $Nul)  'pad with Chr$(0)
   Rows    = Len(TextData$)/HexWidth         '# rows needed in Buffer$
   Buffer$ = Repeat$(Rows, HexTemplate$)  'empty Buffer$ (contains rows of templates)

   'Add the Hex data to the output buffer
   pHexTable = StrPtr(HexTable$)
   pTextData = StrPtr(TextData$)
   pBuffer   = StrPtr(Buffer$)
   pHexDigit = StrPtr(HexDigit$)
   For i = 0 To Rows-1
       iPos = i * HexWidth
       For j = 0 To HexWidth-1
           If j < 6 Then
               @pBuffer[5-j] = @pHexDigit[iPos Mod 16]         'character position
               iPos = iPos \ 16
           End If
           @pBuffer[9 + j*3] = @pHexTable[@pTextData * 2]    'hex data 1st byte
           @pBuffer[10 + j*3] = @pHexTable[@pTextData * 2+1]  'hex data 2nd byte
           @pBuffer[TextPos + j]  = Rep(@pTextData)               'text data
           Incr pTextData
       Next j
       pBuffer = pBuffer + tLength
   Next i
   Function = Buffer$
End Function

Sub SetHexWidth
   If Debug Then Txt.Print FuncName$
   Local iResult,x,y As Long, temp$
   Dialog Get Loc hDlg To x,y
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Hex Display Width (Chars)", Str$(HexWidth), x+100,y+100)
   UnhookWindowsHookEx ghHook
   If Len(temp$) Then
      iResult = Val(temp$)
      If iResult>0 Then
         CustomHexWidth = Val(temp$)
         HexWidth = CustomHexWidth
         If AutoWidth Then SetDialogWidth
      End If
   End If
End Sub

Sub SetGoodCharacters
   If Debug Then Txt.Print FuncName$
   Local x,y As Long, temp$
   Dialog Get Loc hDlg To x,y
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "Visible Characters", GoodChar, x+100,y+100)
   UnhookWindowsHookEx ghHook
   If Len(temp$) Then GoodChar = temp$
End Sub

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$ ... disabled by choice
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub DisplaySearchDialog()
   If Debug Then Txt.Print FuncName$
   Local w,h As Long
   Dialog Get Client hDlg To h,w
   Dialog Font "Tahoma",10,0
   Dialog New Pixels, hDlg, "Find", 100, 100, 340, 70, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hSearch
   Dialog Set Icon hSearch, "xsearch"

   Control Add Label, hSearch, %IDS_FindThisLabel, "Find This:", 5, 10, 80, 20

   If Len(SelectedREText) Then SearchTerm = SelectedREText
   Control Add TextBox, hSearch, %IDS_SearchTerm, SearchTerm, 90, 10, 150, 20

   Control Add Button, hSearch, %IDS_SearchPrevious, "Find Prev", 250, 10, 80, 25
   Control Add Button, hSearch, %IDS_SearchNext, "Find Next", 250, 40, 80, 25

   Control Add CheckBox, hSearch, %IDS_CaseSensitive, "Case Sensitive", 10, 40, 100, 20
   Control Set Check hSearch, %IDS_CaseSensitive, CaseSensitive

   Control Add Button, hSearch, %IdOk, "Ok", 200, 230, 20, 20
   Control Add Button, hSearch, %IdCancel, "Cancel", 230, 230, 20, 20
   Control Show State hSearch, %IdOk, %SW_Hide
   Control Show State hSearch, %IdCancel, %SW_Hide

   SearchDialogShown = 1
   Dialog Show Modeless hSearch Call SearchProc()
   Do                                                                    'because we want to be able
      Dialog DoEvents                                                     'to edit main text while
   Loop Until SearchDialogShown = 0

End Sub

CallBack Function SearchProc() As Long
'   If Debug Then Txt.Print FuncName$ ... disabled by choice
   Select Case Cb.Msg
      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then          'trap Alt-F4 and X Button
            SearchDialogShown = 0
         End If

      Case %IdCancel
         Dialog End hSearch
         SearchDialogShown = 0

      Case %WM_Destroy
         SearchDialogShown = 0

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDS_SearchTerm
               Select Case Cb.CtlMsg
                  Case %EN_Change
                     Control Get Text hSearch, %IDS_SearchTerm To SearchTerm
               End Select

            Case %IDS_CaseSensitive
               Control Get Check hSearch, %IDS_CaseSensitive To CaseSensitive

            Case %IdCancel
               Dialog End hSearch

            Case %IdOk
               Control Send hDlg, %IDC_RichEdit, %EM_EXGetSel, 0, VarPtr(ft.chrg)
               FindTextInDisplay
            Case %IDS_SearchNext                                                   'search forward
               SearchNext
            Case %IDS_SearchPrevious                                                'search backward
               SearchPrevious
         End Select
   End Select
End Function

Function FindTextinDisplay() As Long
   If Debug Then Txt.Print FuncName$
   Local sTerm$, iResult As Long
   sTerm$ = IIf$(CaseSensitive, SearchTerm, LCase$(SearchTerm))
   ft.lpstrText = StrPtr(sTerm$)

   If SearchDirection Then  'search next
       ft.chrg.cpmin = ft.chrg.cpmax
       ft.chrg.cpmax = -1   'end of document
       Control Send hDlg, %IDC_RichEdit, %EM_FindTextEX, %FR_Down + %FR_MatchCase*CaseSensitive, VarPtr(ft) To iResult
   Else                     'search previous
       ft.chrg.cpmin -= 1
       ft.chrg.cpmax =  0   'start of document
       Control Send hDlg, %IDC_RichEdit, %EM_FindTextEX, %FR_MatchCase*CaseSensitive, VarPtr(ft) To iResult
   End If

   If iResult > -1 Then
       Control Send hDlg, %IDC_RichEdit, %EM_EXSetSel, 0, VarPtr(ft.chrgText)
       Control Send hDlg, %IDC_RichEdit, %EM_ScrollCaret, 0, 0
       Function = 1
   End If
End Function

Function SelectedREText() As String
   If Debug Then Txt.Print FuncName$
   Local P As CharRange, buf$
   SendMessage hRichEdit, %EM_EXGetSel, 0, VarPtr(P)
   buf$ = Space$(P.cpmax - P.cpmin +1)
   SendMessage(hRichEdit, %EM_GetSelText, 0, StrPtr(buf$))   'selection start/stop, caret if none
   Function = RTrim$(buf$, $Nul)
End Function

Sub SearchNext
   If Debug Then Txt.Print FuncName$
   SearchDirection = 1
   Control Send hDlg, %IDC_RichEdit, %EM_EXGetSel, 0, VarPtr(ft.chrg)
   FindTextInDisplay
End Sub

Sub SearchPrevious
   If Debug Then Txt.Print FuncName$
   SearchDirection = 0
   Control Send hDlg, %IDC_RichEdit, %EM_EXGetSel, 0, VarPtr(ft.chrg)
   FindTextinDisplay
End Sub

Sub SetMenusAndToolbar
   If Debug Then Txt.Print FuncName$
   'Toolbar Buttons
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_HexView, HexView * %TBState_Checked Or %TBState_Enabled
   'Menus
    Menu Set State hSettings, ByCmd %IDM_AutoWidth, AutoWidth * %MFS_Checked Or %MFS_Enabled
End Sub

Sub SetDialogWidth
   If Debug Then Txt.Print FuncName$
   If HexView = 0 Then Exit Sub
   Local hBMP As Dword, w,h,x,y As Long, LineOfText$

   LineOfText = Repeat$(7 + 1 + 3 * HexWidth + 1 + 1 + HexWidth + 1 + 2 + 2, "A")

   Graphic Bitmap New 100,100 To hBmp  'size of memory bitmap does not matter
   Graphic Attach hBMP,0
   Graphic Set Font hFont
   Graphic Text Size LineofText$ To x,y
   Graphic Bitmap End
   Dialog Get Client hDlg To w,h
   Dialog Set Client hDlg, x,h
End Sub

Function NewREProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$ ... disabled by choice
   Select Case Msg
      Case %WM_ContextMenu
   End Select
   Function = CallWindowProc(OldREProc, hWnd, Msg, wParam, lParam)
End Function

Function UpdateDialogStatusBar() As Long
   If Debug Then Txt.Print FuncName$
   Dialog Set Text hDlg, "gbHexViewer   v" + $ver + "     " + IIf$(HexView=8,FileName,PathName$(Namex,FileName))
   Statusbar Set Text hDlg, %IDC_StatusBar, 2,0, IIf$(HexView, "  Hex Display Width:  " + Str$(HexWidth), "  Text View Mode")
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "  File Size:  " + Format$(FileSize, "###,###,##0") + " (bytes)"
End Function

Sub ManageDebug
   Local hDebug As Dword
   If Debug Then Txt.Print FuncName$
   If Debug Then
      Txt.Window "Debug", 300,300,40,40 To hDebug
      Txt.Print "TXT Window Opened"
   Else
      Txt.End
   End If
End Sub
